(* Content-type: application/vnd.wolfram.cdf.text *)

(*** Wolfram CDF File ***)
(* http://www.wolfram.com/cdf *)

(* CreatedBy='Mathematica 10.3' *)

(*************************************************************************)
(*                                                                       *)
(*  The Mathematica License under which this file was created prohibits  *)
(*  restricting third parties in receipt of this file from republishing  *)
(*  or redistributing it by any means, including but not limited to      *)
(*  rights management or terms of use, without the express consent of    *)
(*  Wolfram Research, Inc. For additional information concerning CDF     *)
(*  licensing and redistribution see:                                    *)
(*                                                                       *)
(*        www.wolfram.com/cdf/adopting-cdf/licensing-options.html        *)
(*                                                                       *)
(*************************************************************************)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[      1064,         20]
NotebookDataLength[     11213,        296]
NotebookOptionsPosition[     11541,        283]
NotebookOutlinePosition[     12065,        305]
CellTagsIndexPosition[     12022,        302]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["Genetic Drift simulator", "Title",
 FontSize->24],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"reps", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Quiet", "[", "\[IndentingNewLine]", 
    RowBox[{"Show", "[", 
     RowBox[{
      RowBox[{"ListPlot", "[", 
       RowBox[{
        RowBox[{"reps", "/", "500"}], ",", 
        RowBox[{"Joined", "\[Rule]", "True"}], ",", 
        RowBox[{"AxesOrigin", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}]}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", "Thick", "}"}]}], ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "timescale"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", ".05"}], ",", "1.05"}], "}"}]}], "}"}]}], ",", 
        RowBox[{"ImageSize", "\[Rule]", "800"}], ",", 
        RowBox[{"AspectRatio", "\[Rule]", ".3"}], ",", 
        RowBox[{"Frame", "\[Rule]", "True"}], ",", 
        RowBox[{"FrameStyle", "\[Rule]", 
         RowBox[{"Directive", "[", 
          RowBox[{"Black", ",", "14"}], "]"}]}], ",", 
        RowBox[{"FrameTicks", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "\"\<0.0\>\""}], "}"}], "}"}], ",", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"i", ",", "i"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", ".1", ",", ".9", ",", ".1"}], "}"}]}], 
                "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "\"\<1.0\>\""}], "}"}], "}"}]}], "]"}], 
             ",", 
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "\"\<0.0\>\""}], "}"}], "}"}], ",", 
               RowBox[{"Table", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"i", ",", "i"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"i", ",", ".1", ",", ".9", ",", ".1"}], "}"}]}], 
                "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "\"\<1.0\>\""}], "}"}], "}"}]}], "]"}]}], 
            "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Table", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"i", ",", 
                 RowBox[{"ToString", "[", 
                  RowBox[{"IntegerPart", "[", "i", "]"}], "]"}]}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"i", ",", "0", ",", "timescale", ",", 
                 RowBox[{"timescale", "*", ".1"}]}], "}"}]}], "]"}], ",", 
             "None"}], "}"}]}], "}"}]}], ",", 
        RowBox[{"FrameLabel", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Time (generations)\>\"", ",", "\"\<Allele Frequency\>\""}], 
          "}"}]}]}], "]"}], ",", 
      RowBox[{"Plot", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", "0", "}"}], ",", 
          RowBox[{"{", "1", "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "0", ",", "timescale"}], "}"}], ",", 
        RowBox[{"PlotStyle", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"Gray", ",", "Dashed"}], "}"}], "}"}]}]}], "]"}]}], "]"}], 
    "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"timescale", ",", "1500", ",", 
       RowBox[{"Style", "[", 
        RowBox[{"\"\<Number of Generations:\>\"", ",", "16"}], "]"}]}], "}"}],
      ",", "0", ",", "3000", ",", "100", ",", 
     RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}], ",", 
     RowBox[{"LabelStyle", "->", 
      RowBox[{"Directive", "[", "16", "]"}]}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"p", ",", "0.5", ",", 
       RowBox[{"Style", "[", 
        RowBox[{
        "\"\<Initial Allele Frequency (\!\(\*SubscriptBox[\(p\), \(0\)]\)):\>\
\"", ",", "16"}], "]"}]}], "}"}], ",", "0", ",", "1", ",", ".1", ",", 
     RowBox[{"Appearance", "\[Rule]", "\"\<Labeled\>\""}], ",", 
     RowBox[{"LabelStyle", "->", 
      RowBox[{"Directive", "[", "16", "]"}]}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Button", "[", 
    RowBox[{"\"\<Next Simulation\>\"", ",", 
     RowBox[{"AppendTo", "[", 
      RowBox[{"reps", ",", 
       RowBox[{"NestList", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"RandomInteger", "[", 
           RowBox[{"BinomialDistribution", "[", 
            RowBox[{"500", ",", 
             RowBox[{"#", "/", "500"}]}], "]"}], "]"}], "&"}], ",", 
         RowBox[{"p", "*", "500"}], ",", "timescale"}], "]"}]}], "]"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"150", ",", "40"}], "}"}]}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", ",", "0"}], "}"}], ",", 
     RowBox[{"ControlType", "\[Rule]", "None"}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Button", "[", 
    RowBox[{"\"\<Clear\>\"", ",", 
     RowBox[{"reps", "=", 
      RowBox[{"{", "}"}]}], ",", 
     RowBox[{"ImageSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"150", ",", "40"}], "}"}]}]}], "]"}]}], "]"}]}], "Code",
 Editable->False,
 CellOpen->False],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`n$$ = 0, $CellContext`p$$ = 
    0.5, $CellContext`timescale$$ = 1500, Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`timescale$$], 1500, 
       Style["Number of Generations:", 16]}, 0, 3000, 100}, {{
       Hold[$CellContext`p$$], 0.5, 
       Style[
       "Initial Allele Frequency (\!\(\*SubscriptBox[\(p\), \(0\)]\)):", 16]},
       0, 1, 0.1}, {
      Hold[
       Button["Next Simulation", 
        AppendTo[$CellContext`reps, 
         NestList[RandomInteger[
           BinomialDistribution[500, #/500]]& , $CellContext`p$$ 
          500, $CellContext`timescale$$]], ImageSize -> {150, 40}]], 
      Manipulate`Dump`ThisIsNotAControl}, {{
       Hold[$CellContext`n$$], 0}}, {
      Hold[
       Button["Clear", $CellContext`reps = {}, ImageSize -> {150, 40}]], 
      Manipulate`Dump`ThisIsNotAControl}}, Typeset`size$$ = {
    800., {130., 135.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
    Typeset`skipInitDone$$ = True, $CellContext`timescale$771$$ = 
    0, $CellContext`p$772$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`n$$ = 0, $CellContext`p$$ = 
        0.5, $CellContext`timescale$$ = 1500}, "ControllerVariables" :> {
        Hold[$CellContext`timescale$$, $CellContext`timescale$771$$, 0], 
        Hold[$CellContext`p$$, $CellContext`p$772$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> Quiet[
        Show[
         ListPlot[$CellContext`reps/500, Joined -> True, AxesOrigin -> {0, 0},
           PlotStyle -> {Thick}, 
          PlotRange -> {{1, $CellContext`timescale$$}, {-0.05, 1.05}}, 
          ImageSize -> 800, AspectRatio -> 0.3, Frame -> True, FrameStyle -> 
          Directive[Black, 14], FrameTicks -> {{
             Join[{{0, "0.0"}}, 
              
              Table[{$CellContext`i, $CellContext`i}, {$CellContext`i, 0.1, 
                0.9, 0.1}], {{1, "1.0"}}], 
             Join[{{0, "0.0"}}, 
              
              Table[{$CellContext`i, $CellContext`i}, {$CellContext`i, 0.1, 
                0.9, 0.1}], {{1, "1.0"}}]}, {
             Table[{$CellContext`i, 
               ToString[
                IntegerPart[$CellContext`i]]}, {$CellContext`i, 
               0, $CellContext`timescale$$, $CellContext`timescale$$ 0.1}], 
             None}}, FrameLabel -> {
           "Time (generations)", "Allele Frequency"}], 
         Plot[{{0}, {1}}, {$CellContext`x, 0, $CellContext`timescale$$}, 
          PlotStyle -> {{Gray, Dashed}}]]], 
      "Specifications" :> {{{$CellContext`timescale$$, 1500, 
          Style["Number of Generations:", 16]}, 0, 3000, 100, Appearance -> 
         "Labeled", LabelStyle -> Directive[16]}, {{$CellContext`p$$, 0.5, 
          Style[
          "Initial Allele Frequency (\!\(\*SubscriptBox[\(p\), \(0\)]\)):", 
           16]}, 0, 1, 0.1, Appearance -> "Labeled", LabelStyle -> 
         Directive[16]}, 
        Button["Next Simulation", 
         AppendTo[$CellContext`reps, 
          NestList[RandomInteger[
            BinomialDistribution[500, #/500]]& , $CellContext`p$$ 
           500, $CellContext`timescale$$]], 
         ImageSize -> {150, 40}], {{$CellContext`n$$, 0}, ControlType -> 
         None}, 
        Button["Clear", $CellContext`reps = {}, ImageSize -> {150, 40}]}, 
      "Options" :> {}, "DefaultOptions" :> {}],
     ImageSizeCache->{845., {236., 241.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UndoTrackedVariables:>{Typeset`show$$, Typeset`bookmarkMode$$},
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 InitializationCell->True]
}, Open  ]]
},
CellGrouping->Manual,
WindowSize->{1680, 1001},
WindowMargins->{{27, Automatic}, {Automatic, 0}},
Visible->True,
ScrollingOptions->{"VerticalScrollRange"->Fit},
ShowCellBracket->Automatic,
CellContext->Notebook,
TrackCellChangeTimes->False,
FrontEndVersion->"10.4 for Mac OS X x86 (32-bit, 64-bit Kernel) (February 25, \
2016)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[1464, 33, 55, 1, 69, "Title"],
Cell[CellGroupData[{
Cell[1544, 38, 5723, 152, 22, "Code",
 CellOpen->False],
Cell[7270, 192, 4255, 88, 494, "Output",
 InitializationCell->True]
}, Open  ]]
}
]
*)

(* NotebookSignature 0x0PVGk3odt1lCw0kVmBnk4D *)
